open import Lib.Equality as Eq using (_==_ ; auto)
open import Lib.Maybe
open import Lib.MaybeEq

open import Index
open import Gate

module Lib.MaybeEq-Instances where

instance
  MaybeEq-Index : MaybeEq Index
  MaybeEq-Index = record { _=m?_ = λ {
    ₀ ₀ → Just Eq.refl ;
    ₁ ₁ → Just Eq.refl ;
    ₂ ₂ → Just Eq.refl ;
    ₃ ₃ → Just Eq.refl ;
    ₄ ₄ → Just Eq.refl ;
    ₅ ₅ → Just Eq.refl ;
    ₆ ₆ → Just Eq.refl ;
    ₇ ₇ → Just Eq.refl;
    _ _ -> Nothing}}

_=G?=_ : (x y : Gate) -> Maybe (x == y)
CCX0-gen =G?= CCX0-gen = Just Eq.refl
CCX1-gen =G?= CCX1-gen = Just Eq.refl
CCX2-gen =G?= CCX2-gen = Just Eq.refl
CX01-gen =G?= CX01-gen = Just Eq.refl
CX10-gen =G?= CX10-gen = Just Eq.refl
CX12-gen =G?= CX12-gen = Just Eq.refl
CX21-gen =G?= CX21-gen = Just Eq.refl
CX02-gen =G?= CX02-gen = Just Eq.refl
CX20-gen =G?= CX20-gen = Just Eq.refl
X0-gen =G?= X0-gen = Just Eq.refl
X1-gen =G?= X1-gen = Just Eq.refl
X2-gen =G?= X2-gen = Just Eq.refl
Swap01-gen =G?= Swap01-gen = Just Eq.refl
Swap12-gen =G?= Swap12-gen = Just Eq.refl
S0-gen =G?= S0-gen = Just Eq.refl
S1-gen =G?= S1-gen = Just Eq.refl
S2-gen =G?= S2-gen = Just Eq.refl
CS01-gen =G?= CS01-gen = Just Eq.refl
CS12-gen =G?= CS12-gen = Just Eq.refl
CS02-gen =G?= CS02-gen = Just Eq.refl
CCZ-gen =G?= CCZ-gen = Just Eq.refl
iI-gen =G?= iI-gen = Just Eq.refl
CCK'-gen =G?= CCK'-gen = Just Eq.refl
CK10-gen =G?= CK10-gen = Just Eq.refl
CK20-gen =G?= CK20-gen = Just Eq.refl
K0-gen =G?= K0-gen = Just Eq.refl
_ =G?= _ = Nothing

instance 
  MaybeEq-Gate : MaybeEq Gate
  MaybeEq-Gate ._=m?_ = _=G?=_ 


